From ee135ee4c57d978594d483af7fcb3997c3e5094b Mon Sep 17 00:00:00 2001
From: Antonin Houska <ah@cybertec.at>
Date: Wed, 15 Jul 2026 10:37:12 +0200
Subject: [PATCH 8/8] Make REPACK (CONCURRENTLY) MVCC-safe.

In the initial implementation of REPACK (CONCURRENTLY), tuples in the new
table are marked with XID of the transaction the command executes in. This is
simpler to implement, but can cause surprising behavior: on specific
conditions, the table contents may become invisible for transactions that
should see it. (Both ALTER TABLE and TRUNCATE commands have this problem.)
Besides that, as REPACK (CONCURRENTLY) needs to have XID assigned (to mark the
new tuples) while it copies the data (which can take long time), it can
restrict the progress of the xmin horizons for VACUUM quite a bit.

This patch teaches REPACK (CONCURRENTLY) to transfer the visibility
information from the old table to the new one. Thus there's no need to have
XID assigned during the copying, and therefore VACUUM (of other tables) is not
restricted anymore.

A new type of snapshot is used to look for the existing tuples in the new
table, in order to apply the concurrent data changes (i.e. changes performed
by other transactions during the initial copying). This snapshot assumes that
the new table does not contain any tuples created by aborted
transactions. This is simpler and more efficient than building historic MVCC
snapshots for the look-ups.

One problem that needs special attention is tuple freezing. Besides page
pruning code, freezing is currently implemented only in rewriteheap.c. Thus it
seems simpler to teach REPACK (CONCURRENTLY) to copy the data using
rewriteheap.c rather than implementing freezing of individual tuples
independent from page pruning. (The latter would include WAL logging of the
individual frozen tuples, whereas rewriteheap.c logs the whole page at once.)
Disadvantage of this approach is that we only freeze tuples during the initial
copying, while the data changes decoded from WAL are replayed without
freezing.

This patch also uses rewriteheap.c (in particular raw_heap_insert()) to insert
TOAST tuples. That seems to be the easiest way to avoid getting XID assigned
just to insert TOAST. However, due to not using a new XID, even TOAST needs to
be frozen now - again, we use the existing code in rewriteheap.c.
---
 doc/src/sgml/mvcc.sgml                        |  12 +-
 doc/src/sgml/ref/repack.sgml                  |   9 -
 src/backend/access/common/toast_internals.c   |  45 +-
 src/backend/access/heap/heapam.c              |  84 +++-
 src/backend/access/heap/heapam_handler.c      | 265 +++++++++--
 src/backend/access/heap/heapam_visibility.c   |  62 +++
 src/backend/access/heap/heaptoast.c           |  23 +-
 src/backend/access/heap/rewriteheap.c         | 263 ++++++++---
 src/backend/access/table/tableam.c            |   1 +
 src/backend/access/table/toast_helper.c       |  11 +-
 src/backend/access/transam/xloginsert.c       |  31 +-
 src/backend/access/transam/xlogrecovery.c     |   7 +-
 src/backend/catalog/indexing.c                |   2 +-
 src/backend/commands/matview.c                |   3 +-
 src/backend/commands/repack.c                 | 433 ++++++++++++------
 src/backend/commands/tablecmds.c              |   1 +
 src/backend/executor/nodeModifyTable.c        |   1 +
 src/backend/replication/logical/decode.c      | 110 ++++-
 .../replication/logical/reorderbuffer.c       |   3 +
 .../utils/activity/wait_event_names.txt       |   1 +
 src/include/access/heapam.h                   |   4 +-
 src/include/access/heaptoast.h                |   7 +-
 src/include/access/rewriteheap.h              |  13 +-
 src/include/access/tableam.h                  |  28 +-
 src/include/access/toast_helper.h             |  14 +-
 src/include/access/toast_internals.h          |   9 +-
 src/include/access/xlog_internal.h            |   2 +-
 src/include/access/xloginsert.h               |   1 +
 src/include/access/xlogrecord.h               |   8 +
 src/include/commands/repack.h                 |  17 +-
 src/include/utils/snapmgr.h                   |  12 +
 src/include/utils/snapshot.h                  |  27 +-
 .../injection_points/expected/repack.out      |  10 +-
 .../injection_points/specs/repack.spec        |  23 +-
 34 files changed, 1200 insertions(+), 342 deletions(-)

diff --git a/doc/src/sgml/mvcc.sgml b/doc/src/sgml/mvcc.sgml
index 9cb52302f23..8a6bb165ecb 100644
--- a/doc/src/sgml/mvcc.sgml
+++ b/doc/src/sgml/mvcc.sgml
@@ -1883,17 +1883,15 @@ SELECT pg_advisory_lock(q.id) FROM
    <title>Caveats</title>
 
    <para>
-    Some commands, currently only <link linkend="sql-truncate"><command>TRUNCATE</command></link>, the
-    table-rewriting forms of <link linkend="sql-altertable"><command>ALTER
-    TABLE</command></link> and <command>REPACK</command> with
-    the <literal>CONCURRENTLY</literal> option, are not
+    Some DDL commands, currently only <link linkend="sql-truncate"><command>TRUNCATE</command></link> and the
+    table-rewriting forms of <link linkend="sql-altertable"><command>ALTER TABLE</command></link>, are not
     MVCC-safe.  This means that after the truncation or rewrite commits, the
     table will appear empty to concurrent transactions, if they are using a
-    snapshot taken before the command committed.  This will only be an
+    snapshot taken before the DDL command committed.  This will only be an
     issue for a transaction that did not access the table in question
-    before the command started &mdash; any transaction that has done so
+    before the DDL command started &mdash; any transaction that has done so
     would hold at least an <literal>ACCESS SHARE</literal> table lock,
-    which would block the truncating or rewriting command until that transaction completes.
+    which would block the DDL command until that transaction completes.
     So these commands will not cause any apparent inconsistency in the
     table contents for successive queries on the target table, but they
     could cause visible inconsistency between the contents of the target
diff --git a/doc/src/sgml/ref/repack.sgml b/doc/src/sgml/ref/repack.sgml
index 0cb72b6b289..acbd92ef79d 100644
--- a/doc/src/sgml/ref/repack.sgml
+++ b/doc/src/sgml/ref/repack.sgml
@@ -300,15 +300,6 @@ REPACK [ ( <replaceable class="parameter">option</replaceable> [, ...] ) ] USING
        </listitem>
       </itemizedlist>
      </para>
-
-     <warning>
-      <para>
-       <command>REPACK</command> with the <literal>CONCURRENTLY</literal>
-       option is not MVCC-safe, see <xref linkend="mvcc-caveats"/> for
-       details.
-      </para>
-     </warning>
-
     </listitem>
    </varlistentry>
 
diff --git a/src/backend/access/common/toast_internals.c b/src/backend/access/common/toast_internals.c
index 77d42e7ed65..ba80fed0ca9 100644
--- a/src/backend/access/common/toast_internals.c
+++ b/src/backend/access/common/toast_internals.c
@@ -112,12 +112,15 @@ toast_compress_datum(Datum value, char cmethod)
  * rel: the main relation we're working with (not the toast rel!)
  * value: datum to be pushed to toast storage
  * oldexternal: if not NULL, toast pointer previously representing the datum
+ * rwstate: state needed for "raw insert".
+ * tup_main: the tuple whose attribute we're saving
  * options: options to be passed to heap_insert() for toast rows
  * ----------
  */
 Datum
 toast_save_datum(Relation rel, Datum value,
-				 varlena *oldexternal, uint32 options)
+				 varlena *oldexternal, RewriteState rwstate,
+				 HeapTuple tup_main, uint32 options)
 {
 	Relation	toastrel;
 	Relation   *toastidxs;
@@ -311,7 +314,40 @@ toast_save_datum(Relation rel, Datum value,
 
 		toasttup = heap_form_tuple(toasttupDesc, t_values, t_isnull);
 
-		heap_insert(toastrel, toasttup, mycid, options, NULL);
+		if (rwstate == NULL)
+		{
+			/*
+			 * With REUSE_XID we'd need regular freezing, however that is
+			 * currently implemented only as a part of VACUUM or in
+			 * rewriteheap.c. On the other hand, tuples containing a new XID
+			 * can be marked as frozen in special cases - see the current uses
+			 * of TABLE_INSERT_FROZEN.
+			 */
+			Assert((options & HEAP_INSERT_FROZEN) == 0 ||
+				   (options & TABLE_REUSE_XID) == 0);
+
+			/*
+			 * If an existing XID should be used, the entire visibility info
+			 * of the TOAST tuple should be equal to that of corresponding
+			 * tuple in the main table.
+			 */
+			if (options & TABLE_REUSE_XID)
+				rewrite_copy_visibility_info(toasttup, tup_main);
+
+			heap_insert(toastrel, toasttup, mycid, options, NULL);
+		}
+		else
+		{
+			/*
+			 * During heap rewrite, XID is always reused and the tuple is
+			 * always frozen - we do not expect the user to tell us what to
+			 * do.
+			 */
+			Assert((options & HEAP_INSERT_FROZEN) == 0 &&
+				   (options & TABLE_REUSE_XID) == 0);
+
+			rewrite_heap_tuple_no_chains(rwstate, tup_main, toasttup, true);
+		}
 
 		/*
 		 * Create the index entry.  We cheat a little here by not using
@@ -373,7 +409,8 @@ toast_save_datum(Relation rel, Datum value,
  * ----------
  */
 void
-toast_delete_datum(Relation rel, Datum value, bool is_speculative)
+toast_delete_datum(Relation rel, Datum value, bool is_speculative,
+				   TransactionId xid)
 {
 	varlena    *attr = (varlena *) DatumGetPointer(value);
 	varatt_external toast_pointer;
@@ -425,7 +462,7 @@ toast_delete_datum(Relation rel, Datum value, bool is_speculative)
 		if (is_speculative)
 			heap_abort_speculative(toastrel, &toasttup->t_self);
 		else
-			simple_heap_delete(toastrel, &toasttup->t_self);
+			simple_heap_delete(toastrel, &toasttup->t_self, xid);
 	}
 
 	/*
diff --git a/src/backend/access/heap/heapam.c b/src/backend/access/heap/heapam.c
index 9cdc221675b..35012434d27 100644
--- a/src/backend/access/heap/heapam.c
+++ b/src/backend/access/heap/heapam.c
@@ -63,7 +63,7 @@ static XLogRecPtr log_heap_update(Relation reln, Buffer oldbuf,
 								  Buffer newbuf, HeapTuple oldtup,
 								  HeapTuple newtup, HeapTuple old_key_tuple,
 								  bool all_visible_cleared, bool new_all_visible_cleared,
-								  bool walLogical);
+								  bool walLogical, TransactionId xid);
 #ifdef USE_ASSERT_CHECKING
 static void check_lock_if_inplace_updateable_rel(Relation relation,
 												 const ItemPointerData *otid,
@@ -2004,7 +2004,7 @@ void
 heap_insert(Relation relation, HeapTuple tup, CommandId cid,
 			uint32 options, BulkInsertState bistate)
 {
-	TransactionId xid = GetCurrentTransactionId();
+	TransactionId xid;
 	HeapTuple	heaptup;
 	Buffer		buffer;
 	Page		page;
@@ -2017,6 +2017,13 @@ heap_insert(Relation relation, HeapTuple tup, CommandId cid,
 
 	AssertHasSnapshotForToast(relation);
 
+	/* The caller might need to preserve the existing xmin. */
+	if ((options & TABLE_REUSE_XID) == 0)
+		xid = GetCurrentTransactionId();
+	else
+		xid = HeapTupleHeaderGetXmin(tup->t_data);
+	Assert(TransactionIdIsValid(xid));
+
 	/*
 	 * Fill in tuple header fields and toast the tuple if necessary.
 	 *
@@ -2159,6 +2166,13 @@ heap_insert(Relation relation, HeapTuple tup, CommandId cid,
 		/* filtering by origin on a row level is much more efficient */
 		XLogSetRecordFlags(XLOG_INCLUDE_ORIGIN);
 
+		/*
+		 * Even if we don't have XID assigned, valid XID is necessary for
+		 * recovery and streaming replication to work.
+		 */
+		if (options & TABLE_REUSE_XID)
+			XLogSetRecordXid(xid);
+
 		recptr = XLogInsert(RM_HEAP_ID, info);
 
 		PageSetLSN(page, recptr);
@@ -2236,7 +2250,7 @@ heap_prepare_insert(Relation relation, HeapTuple tup, TransactionId xid,
 		return tup;
 	}
 	else if (HeapTupleHasExternal(tup) || tup->t_len > TOAST_TUPLE_THRESHOLD)
-		return heap_toast_insert_or_update(relation, tup, NULL, options);
+		return heap_toast_insert_or_update(relation, tup, NULL, NULL, options);
 	else
 		return tup;
 }
@@ -2299,6 +2313,8 @@ heap_multi_insert(Relation relation, TupleTableSlot **slots, int ntuples,
 
 	/* currently not needed (thus unsupported) for heap_multi_insert() */
 	Assert(!(options & HEAP_INSERT_NO_LOGICAL));
+	/* Likewise. */
+	Assert(!(options & TABLE_REUSE_XID));
 
 	AssertHasSnapshotForToast(relation);
 
@@ -2715,11 +2731,11 @@ xmax_infomask_changed(uint16 new_infomask, uint16 old_infomask)
  */
 TM_Result
 heap_delete(Relation relation, const ItemPointerData *tid,
-			CommandId cid, uint32 options, Snapshot crosscheck,
+			TransactionId xid, CommandId cid, uint32 options,
+			Snapshot crosscheck,
 			bool wait, TM_FailureData *tmfd)
 {
 	TM_Result	result;
-	TransactionId xid = GetCurrentTransactionId();
 	ItemId		lp;
 	HeapTupleData tp;
 	Page		page;
@@ -2736,11 +2752,14 @@ heap_delete(Relation relation, const ItemPointerData *tid,
 	bool		all_visible_cleared = false;
 	HeapTuple	old_key_tuple = NULL;	/* replica identity of the tuple */
 	bool		old_key_copied = false;
+	bool		override_xid = false;
 
 	Assert(ItemPointerIsValid(tid));
 
 	AssertHasSnapshotForToast(relation);
 
+	Assert((options & TABLE_REUSE_XID) == 0);
+
 	/*
 	 * Forbid this during a parallel operation, lest it allocate a combo CID.
 	 * Other workers might need that combo CID for visibility checks, and we
@@ -2751,6 +2770,12 @@ heap_delete(Relation relation, const ItemPointerData *tid,
 				(errcode(ERRCODE_INVALID_TRANSACTION_STATE),
 				 errmsg("cannot delete tuples during a parallel operation")));
 
+	/* Caller can override the xid. */
+	if (!TransactionIdIsValid(xid))
+		xid = GetCurrentTransactionId();
+	else
+		override_xid = true;
+
 	block = ItemPointerGetBlockNumber(tid);
 	buffer = ReadBuffer(relation, block);
 	page = BufferGetPage(buffer);
@@ -3089,6 +3114,9 @@ l1:
 
 		/* filtering by origin on a row level is much more efficient */
 		XLogSetRecordFlags(XLOG_INCLUDE_ORIGIN);
+		/* See heap_insert() for details. */
+		if (override_xid)
+			XLogSetRecordXid(xid);
 
 		recptr = XLogInsert(RM_HEAP_ID, XLOG_HEAP_DELETE);
 
@@ -3115,7 +3143,7 @@ l1:
 		Assert(!HeapTupleHasExternal(&tp));
 	}
 	else if (HeapTupleHasExternal(&tp))
-		heap_toast_delete(relation, &tp, false);
+		heap_toast_delete(relation, &tp, false, xid);
 
 	/*
 	 * Mark tuple for invalidation from system caches at next command
@@ -3148,14 +3176,18 @@ l1:
  * the target tuple are not expected (for example, because we have a lock
  * on the relation associated with the tuple).  Any failure is reported
  * via ereport().
+ *
+ * XXX Add simple_heap_delete_xid() so that the signature of this function can
+ * stay intact?
  */
 void
-simple_heap_delete(Relation relation, const ItemPointerData *tid)
+simple_heap_delete(Relation relation, const ItemPointerData *tid,
+				   TransactionId xid)
 {
 	TM_Result	result;
 	TM_FailureData tmfd;
 
-	result = heap_delete(relation, tid,
+	result = heap_delete(relation, tid, xid,
 						 GetCurrentCommandId(true),
 						 0,
 						 InvalidSnapshot,
@@ -3204,7 +3236,7 @@ heap_update(Relation relation, const ItemPointerData *otid, HeapTuple newtup,
 			TU_UpdateIndexes *update_indexes)
 {
 	TM_Result	result;
-	TransactionId xid = GetCurrentTransactionId();
+	TransactionId xid;
 	Bitmapset  *hot_attrs;
 	Bitmapset  *sum_attrs;
 	Bitmapset  *key_attrs;
@@ -3267,6 +3299,13 @@ heap_update(Relation relation, const ItemPointerData *otid, HeapTuple newtup,
 	check_lock_if_inplace_updateable_rel(relation, otid, newtup);
 #endif
 
+	/* The caller might need to preserve the existing xmin. */
+	if ((options & TABLE_REUSE_XID) == 0)
+		xid = GetCurrentTransactionId();
+	else
+		xid = HeapTupleHeaderGetXmin(newtup->t_data);
+	Assert(TransactionIdIsValid(xid));
+
 	/*
 	 * Fetch the list of attributes to be checked for various operations.
 	 *
@@ -3871,7 +3910,8 @@ l2:
 		if (need_toast)
 		{
 			/* Note we always use WAL and FSM during updates */
-			heaptup = heap_toast_insert_or_update(relation, newtup, &oldtup, 0);
+			heaptup = heap_toast_insert_or_update(relation, newtup, &oldtup,
+												  NULL, options);
 			newtupsize = MAXALIGN(heaptup->t_len);
 		}
 		else
@@ -4099,7 +4139,9 @@ l2:
 								 old_key_tuple,
 								 all_visible_cleared,
 								 all_visible_cleared_new,
-								 walLogical);
+								 walLogical,
+								 options & TABLE_REUSE_XID ? xid : InvalidTransactionId);
+
 		if (newbuf != buffer)
 		{
 			PageSetLSN(newpage, recptr);
@@ -5297,7 +5339,9 @@ compute_new_xmax_infomask(TransactionId xmax, uint16 old_infomask,
 	uint16		new_infomask,
 				new_infomask2;
 
-	Assert(TransactionIdIsCurrentTransactionId(add_to_xmax));
+	/* REPACK (CONCURRENTLY) might not have XID assigned. */
+	Assert(TransactionIdIsCurrentTransactionId(add_to_xmax) ||
+		   !TransactionIdIsValid(GetTopTransactionIdIfAny()));
 
 l5:
 	new_infomask = 0;
@@ -6269,7 +6313,9 @@ heap_abort_speculative(Relation relation, const ItemPointerData *tid)
 	if (HeapTupleHasExternal(&tp))
 	{
 		Assert(!IsToastRelation(relation));
-		heap_toast_delete(relation, &tp, true);
+		/* XID overriding is not needed for speculative abort. */
+		Assert(TransactionIdIsValid(GetCurrentTransactionIdIfAny()));
+		heap_toast_delete(relation, &tp, true, GetCurrentTransactionId());
 	}
 
 	/*
@@ -6695,7 +6741,8 @@ FreezeMultiXactId(MultiXactId multi, uint16 t_infomask,
 		pagefrz->freeze_required = true;
 		return InvalidTransactionId;
 	}
-	else if (MultiXactIdPrecedes(multi, cutoffs->relminmxid))
+	else if (MultiXactIdIsValid(cutoffs->relminmxid) &&
+			 MultiXactIdPrecedes(multi, cutoffs->relminmxid))
 		ereport(ERROR,
 				(errcode(ERRCODE_DATA_CORRUPTED),
 				 errmsg_internal("found multixact %u from before relminmxid %u",
@@ -7199,7 +7246,8 @@ heap_prepare_freeze_tuple(HeapTupleHeader tuple,
 	else if (TransactionIdIsNormal(xid))
 	{
 		/* Raw xmax is normal XID */
-		if (TransactionIdPrecedes(xid, cutoffs->relfrozenxid))
+		if (TransactionIdIsValid(cutoffs->relfrozenxid) &&
+			TransactionIdPrecedes(xid, cutoffs->relfrozenxid))
 			ereport(ERROR,
 					(errcode(ERRCODE_DATA_CORRUPTED),
 					 errmsg_internal("found xmax %u from before relfrozenxid %u",
@@ -8776,7 +8824,7 @@ log_heap_update(Relation reln, Buffer oldbuf,
 				Buffer newbuf, HeapTuple oldtup, HeapTuple newtup,
 				HeapTuple old_key_tuple,
 				bool all_visible_cleared, bool new_all_visible_cleared,
-				bool walLogical)
+				bool walLogical, TransactionId xid)
 {
 	xl_heap_update xlrec;
 	xl_heap_header xlhdr;
@@ -8983,6 +9031,10 @@ log_heap_update(Relation reln, Buffer oldbuf,
 	/* filtering by origin on a row level is much more efficient */
 	XLogSetRecordFlags(XLOG_INCLUDE_ORIGIN);
 
+	/* See heap_insert() for details. */
+	if (TransactionIdIsValid(xid))
+		XLogSetRecordXid(xid);
+
 	recptr = XLogInsert(RM_HEAP_ID, info);
 
 	return recptr;
